﻿namespace Centido.Core.Test
{
    using System;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    /// <summary>
    /// Testing datetime table column
    /// </summary>
    [TestClass]
    public class DateTimeColumnTest : ColumnBaseTest<DateTime?>
    {
        /// <summary>
        /// Datetime table column
        /// </summary>
        // ReSharper disable UnusedMember.Local
        private DateTimeColumn Column
        // ReSharper restore UnusedMember.Local
        {
            get { return GenericColumn as DateTimeColumn; }
        }

        /// <summary>
        /// Get column type
        /// </summary>
        /// <returns></returns>
        protected override ColumnType GetColumnType()
        {
            return ColumnType.DateTime;
        }

        /// <summary>
        /// Get large data
        /// </summary>
        /// <returns></returns>
        protected override DateTime? GetLargeValue()
        {
            return new DateTime(2010, 1, 1);
        }

        /// <summary>
        /// Get small data
        /// </summary>
        /// <returns></returns>
        protected override DateTime? GetSmallValue()
        {
            return new DateTime(1900, 1, 1);
        }

        /// <summary>
        /// Convert db value
        /// </summary>
        /// <param name="dbValue">Db value</param>
        /// <returns></returns>
        protected override DateTime? ConvertDbValue(object dbValue)
        {
            return DbValue.GetDateTime(dbValue);
        }
    }
}