﻿namespace Centido.Core.Test
{
    using System;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    /// <summary>
    /// Testing guid table columns
    /// </summary>
    [TestClass]
    public class GuidColumnTest : ColumnBaseTest<Guid?>
    {
        /// <summary>
        /// Get column type
        /// </summary>
        /// <returns></returns>
        protected override ColumnType GetColumnType()
        {
            return ColumnType.Guid;
        }

        /// <summary>
        /// Get large value
        /// </summary>
        /// <returns></returns>
        protected override Guid? GetLargeValue()
        {
            return Guid.NewGuid();
        }

        /// <summary>
        /// Get small value
        /// </summary>
        /// <returns></returns>
        protected override Guid? GetSmallValue()
        {
            return Guid.NewGuid();
        }

        /// <summary>
        /// Convert db value
        /// </summary>
        /// <param name="dbValue">Db value</param>
        /// <returns></returns>
        protected override Guid? ConvertDbValue(object dbValue)
        {
            return DbValue.GetGuid(dbValue);
        }
    }
}