﻿// -----------------------------------------------------------------------
// <copyright file="IDefaultable.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core
{
    using System.Diagnostics.CodeAnalysis;

    /// <summary>
    ///   Provides the default value.
    /// </summary>
    /// <typeparam name = "T">The type of the value.</typeparam>
    [SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Defaultable")]
    public interface IDefaultable<T>
    {
        /// <summary>
        ///   Gets or sets the default value.
        /// </summary>
        T DefaultValue { get; set; }
    }
}