﻿// -----------------------------------------------------------------------
// <copyright file="IIdentifiedById.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core
{
    using System;

    /// <summary>
    ///   Represents an object that is identified by id.
    /// </summary>
    public interface IIdentifiedById
    {
        /// <summary>
        ///   Gets the object id.
        /// </summary>
        Guid Id { get; }


        /// <summary>
        ///   Gets the id of the object in the binary format.
        /// </summary>
        /// <returns>Returns the id of the object in the binary format.</returns>
        byte[] GetRawId();
    }
}