﻿// -----------------------------------------------------------------------
// <copyright file="ITableAccessEntry.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core
{
    /// <summary>
    ///   Represents a security access right.
    /// </summary>
    public interface ITableAccessRight
    {
        /// <summary>
        ///   Gets the user that has an access right.
        /// </summary>
        User User { get; }

        /// <summary>
        ///   Gets the table.
        /// </summary>
        Table Table { get; }

        /// <summary>
        ///   Gets the granted data action.
        /// </summary>
        DataAction DataAction { get; }
    }
}