﻿// -----------------------------------------------------------------------
// <copyright file="ColumnType.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core
{
    /// <summary>
    ///   Table column type.
    /// </summary>
    public enum ColumnType
    {
        /// <summary>
        ///   A string column.
        /// </summary>
        String,

        /// <summary>
        ///   A small integer column (int16).
        /// </summary>
        SmallInteger,

        /// <summary>
        ///   A reference column.
        /// </summary>
        Reference,

        /// <summary>
        ///   A numeric column (decimal).
        /// </summary>
        Decimal,

        /// <summary>
        ///   An integer column (int32).
        /// </summary>
        Integer,

        /// <summary>
        ///   An enumeration column.
        /// </summary>
        Enumeration,

        /// <summary>
        ///   A DateTime column (without time zone).
        /// </summary>
        DateTime,

        /// <summary>
        ///   A boolean column.
        /// </summary>
        Boolean,

        /// <summary>
        ///   A binary column.
        /// </summary>
        Binary,

        /// <summary>
        ///   A big integer column (int64).
        /// </summary>
        BigInteger,

        /// <summary>
        ///   A guid column.
        /// </summary>
        Guid,

        /// <summary>
        ///   A text column.
        /// </summary>
        Text
    }
}