﻿namespace Centido.Management.ConsoleManager
{
    /// <summary>
    ///   A set of console commands that can be executed before a user logs in.
    /// </summary>
    internal class PreLoginCommandSet : CommandSet
    {
        /// <summary>
        ///   Creates a new instance of the <see cref="Centido.Management.ConsoleManager.PreLoginCommandSet"/> class.
        /// </summary>
        public PreLoginCommandSet()
        {
            PopulateCommandSet();
        }


        /// <summary>
        ///   Populates the command set.
        /// </summary>
        private void PopulateCommandSet()
        {
            RegisterCommand(new LoginCommand());
            RegisterCommand(new InstallCommand());
            RegisterCommand(new UninstallCommand());
        }
    }
}
