﻿// -----------------------------------------------------------------------
// <copyright file="CoreConfigurationSection.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core.Configuration
{
    using System.Configuration;

    /// <summary>
    ///   Application settings section containing data access parameters
    /// </summary>
    public sealed class CoreConfigurationSection : ConfigurationSection
    {
        /// <summary>
        ///   Default section name
        /// </summary>
        public const string DefaultSectionName = "Centido.Core.Configuration";

        /// <summary>
        ///   Collection of domain parameters
        /// </summary>
        [ConfigurationProperty("domains", IsRequired = true, IsDefaultCollection = true)]
        public DomainCollection Domains
        {
            get { return (DomainCollection)this["domains"]; }
        }
    }
}