﻿// -----------------------------------------------------------------------
// <copyright file="IBoundable.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core
{
    using System.Diagnostics.CodeAnalysis;

    /// <summary>
    ///   Provides the bounds of the value.
    /// </summary>
    /// <typeparamref name = "T">The type of the value.</typeparamref>
    [SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Boundable")]
    public interface IBoundable<T>
    {
        /// <summary>
        ///   Gets or sets the maximum.
        /// </summary>
        T Maximum { get; set; }

        /// <summary>
        ///   Gets or sets the minimum.
        /// </summary>
        T Minimum { get; set; }
    }
}