﻿// -----------------------------------------------------------------------
// <copyright file="IRemovable.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core
{
    /// <summary>
    ///   Represents an object that can be deleted.
    /// </summary>
    public interface IRemovable
    {
        /// <summary>
        ///   Deletes the object.
        /// </summary>
        void Delete();


        /// <summary>
        ///   Checks the existence of the object.
        /// </summary>
        /// <returns>Returns true if the object still exists; otherwise, returns false.</returns>
        bool Exists();
    }
}