﻿// -----------------------------------------------------------------------
// <copyright file="AccessLevel.cs" company="JSC Centido">
//  Copyright (c) JSC Centido. All rights reserved.
// </copyright>
// -----------------------------------------------------------------------

namespace Centido.Core
{
    using System.Diagnostics.CodeAnalysis;

    /// <summary>
    ///   Data access levels.
    /// </summary>
    [SuppressMessage("Microsoft.Design", "CA1008:EnumsShouldHaveZeroValue")]
    public enum AccessLevel
    {
        /// <summary>
        ///   Access to own data only.
        /// </summary>
        Own = 1,

        /// <summary>
        ///   Access to own and unit data only.
        /// </summary>
        Unit = 2,

        /// <summary>
        ///   Access to own and lower units data only.
        /// </summary>
        ChildUnits = 3,

        /// <summary>
        ///   Access to own and higher units data only.
        /// </summary>
        ParentUnits = 4,

        /// <summary>
        ///   Access to own, higher and lower units data only.
        /// </summary>
        ChildAndParentUnits = 5,

        /// <summary>
        ///   Access to all data.
        /// </summary>
        All = 6
    }
}